from vcCommand import *

#rSimInterface
#rPythonScript
#rSimBoolSignal
#rSimStatistics
#rOneWayPath
#rResourceSensor

cmd = getCommand()
app = cmd.Application 
sel = app.SelectionManager

def OnStart():
  savefile()

def savefile():
  delimiter = ';'
  uri = ''
  dicts = {}
  list_of_lists = []
  signal_list = []
  savecmd = app.findCommand('dialogSaveFile')
  filefilter = 'CSV table (*.csv)|*.csv|All files (*.*)|*.*'
  savecmd.execute(uri, True, filefilter, 'Choose location to save file')
  if not savecmd.Param_2:
    print 'No file path was selected' 
    return
  uri = savecmd.Param_1
  file_uri = uri[8:]
  titles = ['Component', 'Signal', 'Connections']

  with open(file_uri, 'w') as output:
    line = delimiter.join(titles)
    output.write(line + '\n')
    component_signal_dict = {}
    
    for comp in app.Components:
      if comp.findBehavioursByType(VC_BOOLEANSIGNAL):
       #finding all signals connected to each other from hidden interface

        component_signal_dict[comp] = {}
        for b in comp.findBehavioursByType(VC_ONETOONEINTERFACE): #, VC_ONETOMANYINTERFACE)
          for from_sec in b.ConnectedFromSections:
            for field in from_sec.Fields:
              if field.Type == VC_SIGNALFIELD:
                to_sec = from_sec.ConnectedToSection

                for to_field in to_sec.Fields:
                  if to_field.Type == VC_SIGNALFIELD:               
                    if not component_signal_dict[comp].get(field.Signal.Name, None):
                      component_signal_dict[comp][field.Signal.Name] = []
                    temp = [to_field.Signal.Component.Name, to_field.Signal.Name]
                    ext_signal = '.'.join(temp)  
                    component_signal_dict[comp][field.Signal.Name].append(ext_signal)  
      #Getting the rest of the signals not connected and adding them to the dict                
      all_signal_be = [x.Name for x in comp.Behaviours if x.Type == 'rSimBoolSignal']
      for key, val in component_signal_dict.iteritems():
        if key.Name == comp.Name: 
          res = [x for x in val.keys() + all_signal_be if x not in val.keys() or x not in all_signal_be]
          new_dict = {}
          for i in res:
            new_dict[i] = '-'
          component_signal_dict[key].update(new_dict) 

    result = ''
    #Data Structure:
    #component_signal_dict = {Component1 : {Signal1 : Connected Signals, Signal2 : }, Component2 : }

    #formatting result and writing it to csv file. 
    #signal_names_list is a val that is itself a dict so k_rows 
    for comp_name, signal_names_list in component_signal_dict.iteritems():
      result += '{}\n'.format(comp_name.Name)
      for k_rows, v_rows in signal_names_list.iteritems():
        result += ('{}{}'.format(delimiter, k_rows))
        result += ('{}{}'.format(delimiter, ', '.join(v_rows)))
        result += '\n'
    output.write(result)
    output.close()
    print 'Succesfully saved file'

addState( None )